// Exception.cs
using System;

namespace TtLisp {
  public class LispException : Exception {}

  public class SymbolUnboundException : LispException {
    private ISymbol symbol;
    public SymbolUnboundException( ISymbol symbol ) {
      this.symbol = symbol;
    }
    public ISymbol Symbol { get { return this.symbol; } }
  }

  public class ConstYetDefinedException : LispException {}
  public class ConstCanNotUndefineException : LispException {}

  public class FunctionIsNotDefinedException : LispException {
    private ISymbol symbol;
    public FunctionIsNotDefinedException( ISymbol symbol ) {
      this.symbol = symbol;
    }
    public ISymbol Symbol { get { return this.symbol; } }
  }

  public class InvalidFunctionException : LispException {}
  public class InvalidLambdaListException : LispException {}
  public class InvalidArgumentException : LispException {}
  public class InvalidArgumentTypeException : InvalidArgumentException {}
  public class InvalidArgumentCountException : InvalidArgumentException {}
  public class ParseException : LispException {}
  public class CanNotParseCharacterException : ParseException {}
  public class NotEncloseLStringException : ParseException {}
  public class InvalidEncloseListException : ParseException {}
  public class UnexpectedEOFException : ParseException {}
  public class FileNotReadException : LispException {}
}
